package io.accumulatenetwork.sdk.generated.apiv2;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.RPCBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("KeyPageIndexQuery")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class KeyPageIndexQuery implements RPCBody {
	private Url url;
	private byte[] key;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public KeyPageIndexQuery url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public KeyPageIndexQuery url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getKey() {
	    return key;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setKey(final byte[] value) {
	    this.key = value;
	}

	public KeyPageIndexQuery key(final byte[] value) {
	    setKey(value);
	    return this;
	}
	public KeyPageIndexQuery key(final String value) {
		try {
			setKey(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
}
